
%define release_version 13

%define _moduledir /%{_lib}/security
%define _kdmrc /etc/kde/kdm/kdmrc
%define RHEV_AGENT_RUNNING /tmp/rhev-agent-running

%if 0%{?rhel}
Name: rhevm-guest-agent
%else
Name: ovirt-guest-agent
%endif
Version: 1.0.5
Release: %{release_version}%{?dist}
Summary: oVirt Guest Agent
Group: Applications/System
License: GPLv2+
URL: http://gerrit.ovirt.org/p/ovirt-guest-agent.git
Source0: http://ghammer.fedorapeople.org/ovirt-guest-agent-%{version}.tar.bz2
ExclusiveArch: i686 x86_64
BuildRequires: python
BuildRequires: automake
BuildRequires: libtool
BuildRequires: pam-devel
Requires: dbus-python
Requires: rpm-python
Requires: python-ethtool >= 0.4-1
Requires: udev >= 095-14.23
Requires: kernel > 2.6.18-238.5.0
Requires: usermode
Obsoletes: rhev-agent
%if 0%{?rhel}
Conflicts: selinux-policy < 3.7.19-155
%endif
%if 0%{?fc16}
Conflicts: selinux-policy < 3.10.0-77
%endif
%if 0%{?fedora} >= 17
Conflicts: selinux-policy < 3.10.0-89
%endif

Patch1: 0001-agent-report-the-old-package-name.patch
Patch2: 0002-plugins-use-rhev-m-in-authentication-s-dialogs.patch
Patch3: 0003-agent-updated-conf-file-to-include-rhevm-guest-agent.patch
Patch4: 0004-agent-Perform-string-sanitization-on-messages.patch 

%package pam-module
Summary: oVirt Guest Agent PAM module
Requires: %{name}
Requires: pam
Obsoletes: rhev-agent-pam-rhev-cred

%package gdm-plugin
Summary: GDM oVirt plug-in
# No gdm-devel package is available for plug-in development. So for now
# we build the gdm package.
%if 0%{?rhel}
Source1: gdm-2.30.4-39.el6.src.rpm

%define gdm_version gdm-2.30.4
%define gdm_release %{gdm_version}-39.el6

%define libauditver 1.0.6
%define pango_version 1.2.0
%define gtk2_version 2.6.0
%define libglade2_version 2.0.0
%define libgnomeui_version 2.2.0
%define scrollkeeper_version 0.3.4
%define pam_version 0.99.8.1-11
%define desktop_file_utils_version 0.2.90
%define gail_version 1.2.0
%define nss_version 3.11.1
%define consolekit_version 0.3.0-9
%define hal_version 0.5.9
%define fontconfig_version 2.6.0

# The following requirements were copied from the gdm.spec file.
BuildRequires: pkgconfig(libcanberra-gtk)
BuildRequires: scrollkeeper >= 0:%{scrollkeeper_version}
BuildRequires: pango-devel >= 0:%{pango_version}
BuildRequires: gtk2-devel >= 0:%{gtk2_version}
BuildRequires: libglade2-devel >= 0:%{libglade2_version}
BuildRequires: libgnomeui-devel >= 0:%{libgnomeui_version}
BuildRequires: pam-devel >= 0:%{pam_version}
BuildRequires: fontconfig >= 0:%{fontconfig_version}
BuildRequires: desktop-file-utils >= %{desktop_file_utils_version}
BuildRequires: gail-devel >= 0:%{gail_version}
BuildRequires: libtool automake autoconf
BuildRequires: libattr-devel
BuildRequires: gettext
BuildRequires: gnome-doc-utils
BuildRequires: libdmx-devel
BuildRequires: audit-libs-devel >= %{libauditver}
BuildRequires: autoconf automake libtool
BuildRequires: intltool
%ifnarch s390 s390x
BuildRequires: xorg-x11-server-Xorg
%endif
BuildRequires: nss-devel >= %{nss_version}
BuildRequires: ConsoleKit
BuildRequires: libselinux-devel
BuildRequires: check-devel
BuildRequires: iso-codes-devel
BuildRequires: gnome-panel-devel
BuildRequires: libxklavier-devel >= 4.0
BuildRequires: DeviceKit-power-devel >= 008
BuildRequires: pkgconfig(libgnomekbdui)
BuildRequires: pkgconfig(libxklavier)
BuildRequires: libXdmcp-devel
%else
BuildRequires: dbus-glib-devel
BuildRequires: gdm-devel
BuildRequires: gobject-introspection-devel
BuildRequires: gtk2-devel
%endif
Requires: %{name}
Requires: gdm
Requires: %{name}-pam-module
Obsoletes: rhev-agent-gdm-plugin-rhevcred

%package kdm-plugin
Summary: KDM oVirt plug-in
BuildRequires: kdebase-workspace-devel
Requires: %{name}
Requires: kdm
Requires: %{name}-pam-module
Obsoletes: rhev-agent-kdm-plugin-rhevcred

%description
This is the oVirt management agent running inside the guest. The agent
interfaces with the oVirt manager, supplying heart-beat info as well as
run-time data from within the guest itself. The agent also accepts
control commands to be run executed within the OS (like: shutdown and
restart).

%description pam-module
The oVirt PAM module provides the functionality necessary to use the
oVirt automatic log-in system.

%description gdm-plugin
The GDM plug-in provides the functionality necessary to use the
oVirt automatic log-in system.

%description kdm-plugin
The KDM plug-in provides the functionality necessary to use the
oVirt automatic log-in system.

%prep
%setup -q -n ovirt-guest-agent-%{version}

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%if 0%{?rhel}
    cp -f gdm2-plugin/gdm2-Makefile.am gdm-plugin/Makefile.am
    cp -f gdm2-plugin/gdm-ovirtcred-extension.c gdm-plugin/
    cp -f gdm2-plugin/gdm-ovirtcred-extension.h gdm-plugin/
    cp -f gdm2-plugin/plugin.c gdm-plugin/

    rpmbuild --define="_topdir %{_topdir}" --recompile %{SOURCE1}
%endif
autoreconf -i -f

%build
%configure \
    --enable-securedir=%{_moduledir} \
    --includedir=%{_includedir}/security \
%if 0%{?rhel}
    --with-gdm-src-dir=%{_topdir}/BUILD/%{gdm_version} \
    --with-simple-greeter-plugins-dir=%{_libdir}/gdm/simple-greeter/plugins \
%endif
    --with-pam-prefix=%{_sysconfdir}
    
make %{?_smp_mflags}

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%if 0%{?rhel}
    # libtool will look for this file when relinking during installation.
    mkdir -p $RPM_BUILD_ROOT%{_libdir}
    cp %{_topdir}/BUILDROOT/%{gdm_release}.%{?_arch}%{_libdir}/libgdmsimplegreeter.so \
        $RPM_BUILD_ROOT%{_libdir}
%endif

%if 0%{?rhel}
    sed -i "s~parent->setObjectName(\"welcome\");~parent->setObjectName(\"talker\");~" kdm-plugin/src/kgreet_ovirtcred.cpp
%endif

make install DESTDIR=$RPM_BUILD_ROOT

%if 0%{?rhel}
    # Install SystemV init script.
    install -Dm 0755 ovirt-guest-agent/ovirt-guest-agent $RPM_BUILD_ROOT%{_initrddir}/ovirt-guest-agent
%else
    # Install systemd script.
    install -Dm 0644 ovirt-guest-agent/ovirt-guest-agent.service $RPM_BUILD_ROOT%{_unitdir}/ovirt-guest-agent.service
%endif
# Create symbolic links to commands that requires root privileges.
ln -sf /usr/bin/consolehelper $RPM_BUILD_ROOT%{_datadir}/ovirt-guest-agent/ovirt-locksession
ln -sf /usr/bin/consolehelper $RPM_BUILD_ROOT%{_datadir}/ovirt-guest-agent/ovirt-shutdown
ln -sf /usr/bin/consolehelper $RPM_BUILD_ROOT%{_datadir}/ovirt-guest-agent/ovirt-hibernate

# Update timestamps on Python files in order to avoid differences between
# .pyc/.pyo files.
touch -r %{SOURCE0} $RPM_BUILD_ROOT%{_datadir}/ovirt-guest-agent/*.py

%if 0%{?rhel}
    # No longer needed and is provided by the gdm package.
    rm -f $RPM_BUILD_ROOT%{_libdir}/libgdmsimplegreeter.so

    rm -f $RPM_BUILD_ROOT%{_libdir}/gdm/simple-greeter/plugins/ovirtcred.a
    rm -f $RPM_BUILD_ROOT%{_libdir}/gdm/simple-greeter/plugins/ovirtcred.la
%else
    rm -f $RPM_BUILD_ROOT%{_libdir}/gdm/simple-greeter/extensions/libovirtcred.a
    rm -f $RPM_BUILD_ROOT%{_libdir}/gdm/simple-greeter/extensions/libovirtcred.la
%endif

rm -f $RPM_BUILD_ROOT%{_moduledir}/pam_ovirt_cred.a
rm -f $RPM_BUILD_ROOT%{_moduledir}/pam_ovirt_cred.la

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/ovirt-guest-agent
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lock/subsys/ovirt-guest-agent

%pre
if [ "$1" -ge 1 ]; then
    # Previous version was not stopped on upgrade and it must be stopped
    # before change the user and group name.
    /sbin/service rhev-agentd status > /dev/null 2>&1 && \
        /sbin/service rhev-agentd stop > /dev/null 2>&1
fi

# The agent's user name was renamed from rhevagent to ovirtagent. So we delete
# the old user name and it will be created with the new user name.
getent passwd rhevagent > /dev/null && userdel rhevagent

getent group ovirtagent > /dev/null || groupadd -r -g 175 ovirtagent
getent passwd ovirtagent > /dev/null || \
    /usr/sbin/useradd -u 175 -g 175 -o -r ovirtagent \
        -c "oVirt Guest Agent" -d / -s /sbin/nologin
exit 0

%post
%if 0%{?rhel}
    /sbin/chkconfig --add ovirt-guest-agent
%else
    /bin/systemctl daemon-reload
%endif

%pretrans
/sbin/service rhev-agentd status > /dev/null 2>&1 && \
    touch %{RHEV_AGENT_RUNNING} || :

%posttrans
/sbin/udevadm trigger --subsystem-match="virtio-ports" \
    --attr-match="name=com.redhat.rhevm.vdsm"
[ -e %{RHEV_AGENT_RUNNING} ] && { /bin/rm %{RHEV_AGENT_RUNNING}; \
    /sbin/service ovirt-guest-agent start; } || :

%post kdm-plugin
if ! grep -q "^PluginsLogin=" "%{_kdmrc}";
then
    sed -i "s~^#PluginsLogin=winbind~PluginsLogin=ovirtcred,classic~" "%{_kdmrc}"
fi

%preun
if [ "$1" -eq 0 ]; then
    %if 0%{?rhel}
        /sbin/service ovirt-guest-agent stop > /dev/null 2>&1
        /sbin/chkconfig --del ovirt-guest-agent
    %else
        /bin/systemctl stop ovirt-guest-agent.service > /dev/null 2>&1
    %endif

    # Send an "uninstalled" notification to vdsm.
    VIRTIO=`grep "^device" %{_sysconfdir}/ovirt-guest-agent.conf | awk '{ print $3; }'`
    if [ -w $VIRTIO ]
    then
        echo '{ "__name__" : "uninstalled" }' >> $VIRTIO
    fi
fi

%postun
%if 0%{?fedora}
if [ "$1" -eq 0 ]; then
    /bin/systemctl daemon-reload
fi
%endif

if [ "$1" -ge 1 ]; then
%if 0%{?rhel}
    /sbin/service ovirt-guest-agent condrestart > /dev/null 2>&1
%else
    /bin/systemctl try-restart ovirt-guest-agent.service >/dev/null 2>&1 || :
%endif
fi

%postun kdm-plugin
if [ "$1" -eq 0 ]
then
    sed -i "s~PluginsLogin=ovirtcred,classic~#PluginsLogin=winbind~" "%{_kdmrc}"
fi

%files
%defattr(-,root,root,-)
%dir %attr (755,ovirtagent,ovirtagent) %{_localstatedir}/log/ovirt-guest-agent
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent.conf
%{_sysconfdir}/dbus-1/system.d/org.ovirt.vdsm.Credentials.conf
%{_sysconfdir}/security/console.apps/ovirt-locksession
%{_sysconfdir}/security/console.apps/ovirt-shutdown
%{_sysconfdir}/security/console.apps/ovirt-hibernate
%{_sysconfdir}/pam.d/ovirt-locksession
%{_sysconfdir}/pam.d/ovirt-shutdown
%{_sysconfdir}/pam.d/ovirt-hibernate
%attr (644,root,root) %{_sysconfdir}/udev/rules.d/55-ovirt-guest-agent.rules
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/ovirt-guest-agent.py*
%{_datadir}/ovirt-guest-agent/OVirtAgentLogic.py*
%{_datadir}/ovirt-guest-agent/VirtIoChannel.py*
%{_datadir}/ovirt-guest-agent/CredServer.py*
%{_datadir}/ovirt-guest-agent/GuestAgentLinux2.py*
%{_datadir}/ovirt-guest-agent/ovirt-locksession
%{_datadir}/ovirt-guest-agent/ovirt-shutdown
%{_datadir}/ovirt-guest-agent/ovirt-hibernate
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/LockActiveSession.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/hibernate
%if 0%{?rhel}
%attr (755,root,root) %{_initrddir}/ovirt-guest-agent
%else
%{_unitdir}/ovirt-guest-agent.service
%endif

%doc AUTHORS COPYING NEWS README

%files pam-module
%defattr(-,root,root,-)
%{_moduledir}/pam_ovirt_cred.so

%files gdm-plugin
%defattr(-,root,root,-)
%config %{_sysconfdir}/pam.d/gdm-ovirtcred
%{_datadir}/icons/hicolor/*/*/*.png
%dir %{_datadir}/gdm/simple-greeter/extensions/ovirtcred
%{_datadir}/gdm/simple-greeter/extensions/ovirtcred/page.ui
%if 0%{?rhel}
%{_libdir}/gdm/simple-greeter/plugins/ovirtcred.so
%else
%{_libdir}/gdm/simple-greeter/extensions/libovirtcred.so
%endif

%files kdm-plugin
%defattr(-,root,root,-)
%config %{_sysconfdir}/pam.d/kdm-ovirtcred
%attr (755,root,root) %{_libdir}/kde4/kgreet_ovirtcred.so

%changelog
* Fri Apr 27 2013 Vinzenz Feenstra <vfeenstr@redhat.com> - 1.0.5-13
- Starting the guest agent service when rhev-agent was installed
Resolves: BZ#956747

* Fri Apr 19 2013 Vinzenz Feenstra <vfeenstr@redhat.com> - 1.0.5-12
- Perform string sanitization on messages sent to virtio
Resolves: BZ#951609

* Thu Dec  4 2012 Gal Hammer <ghammer@redhat.com> - 1.0.5-8
- don't fail installation if old user (rhevagent) exists.
- don't call /bin/systemctl when postun on rhel.
- updated conf file to include rhevm-guest-agent.
- obsoletes the rhev-agent package.
- conflicts with selinux-policy lower than 3.7.19-155
Resolves: BZ#881386 BZ#881761 BZ#881879

* Wed Aug  1 2012 Gal Hammer <ghammer@redhat.com> - 1.0.5-3
-  use rhev-m in authentication's dialogs (bz#841470).
Resolves: BZ#841470

* Wed Jul  6 2012 Gal Hammer <ghammer@redhat.com> - 1.0.5-1
- fixed 'udevadm trigger' command line (bz#827141).
- fixed various rpmlint errors and warnings.
Resolves: BZ#827141

* Tue May  8 2012 Gal Hammer <ghammer@redhat.com> - 1.0.4-2
- replaced "with" usage with a python 2.4 compatible way.
- added files to support RHEL-5 distribution.
- added more detailed memory statistics.
- report agent old package name.
Resolves: BZ#803503

* Tue Apr 10 2012 Gal Hammer <ghammer@redhat.com> - 1.0.3-2
- package was renamed to rhevm-guest-agent in RHEL distribution.
- fixed gdm-plugin build requires.
Resolves: BZ#803503

* Wed Mar 28 2012 Gal Hammer <ghammer@redhat.com> - 1.0.2-1
- included a gpl-v2 copying file.
- build the gdm-plugin using the gdm-devel package.
- added a support for RHEL distribution.

* Wed Feb 22 2012 Gal Hammer <ghammer@redhat.com> - 1.0.1-2
- updated required selinux-policy version (related to rhbz#791113).
- added a support to hibernate (s4) command.
- renamed user name to ovirtguest.
- reset version numbering after changing the package name.

* Thu Sep 27 2011 Gal Hammer <ghammer@redhat.com> - 2.3.15-1
- fixed disk usage report when mount point include spaces.
- added a minimum version for python-ethtool.
Resolves: BZ#736426

* Thu Sep 22 2011 Gal Hammer <ghammer@redhat.com> - 2.3.14-1
- added a new 'echo' command to support testing.
Resolves: BZ#736426

* Thu Sep 15 2011 Gal Hammer <ghammer@redhat.com> - 2.3.13-1
- report new network interaces information (ipv4, ipv6 and
  mac address).
- added disks usage report.
- a new json-based protocol with the vdsm.
Resolves: BZ#729252 BZ#736426

* Mon Aug  8 2011 Gal Hammer <ghammer@redhat.com> - 2.3.12-1
- replaced password masking with a fixed-length string.
Resolves: BZ#727506 

* Thu Aug  4 2011 Gal Hammer <ghammer@redhat.com> - 2.3.11-1
- send an 'uninstalled' notification to vdsm
- mask the user's password in the credentials block
Resolves: BZ#727647 BZ#727506

* Mon Aug  1 2011 Gal Hammer <ghammer@redhat.com> - 2.3.10-2
- fixed selinux-policy required version.
Resolves: BZ#694088

* Mon Jul 25 2011 Gal Hammer <ghammer@redhat.com> - 2.3.10-1
- various fixes after failing the errata's rpmdiff.
- added selinux-policy dependency.
Resolves: BZ#720144 BZ#694088

* Thu Jun 16 2011 Gal Hammer <ghammer@redhat.com> - 2.3.9-1
- read report rate values from configuration file.
- replaced executing privilege commands from sudo to
  consolehelper.
Resolves: BZ#713079 BZ#632959

* Tue Jun 14 2011 Gal Hammer <ghammer@redhat.com> - 2.3.8-1
- execute the agent with a non-root user.
- changed the shutdown timeout value to work in minutes.
- update pam config files to work with selinux.
- fixed the local user check when stripping the domain part.
Resolves: BZ#632959 BZ#711428 BZ#694088 BZ#661713 BZ#681123

* Tue May 25 2011 Gal Hammer <ghammer@redhat.com> - 2.3.7-1
- stopped removing the domain part from the user name.
- show only network interfaces that are up and running.
Resolves: BZ#661713 BZ#681123 BZ#704845

* Mon Apr 4 2011 Gal Hammer <ghammer@redhat.com> - 2.3.6-1
- added kdm greeter plug-in.
Resolves: BZ#681123

* Mon Mar 14 2011 Gal Hammer <ghammer@redhat.com> - 2.3.5-1
- replaced rhevcredserver execution from blocking main loop to
  context's iteration (non-blocking).
Resolves: BZ#683493

* Thu Mar 10 2011 Gal Hammer <ghammer@redhat.com> - 2.3.4-1
- added some sleep-ing to init script in order to give udev
  some time to create the symbolic links.
- changed the kernel version condition.
Resolves: BZ#676625 BZ#681527

* Wed Mar 2 2011 Gal Hammer <ghammer@redhat.com> - 2.3.3-1
- removed unused file (rhevcredserver) from rhel-5 build.
- added udev and kernel minimum version requirment.
- fixed pid file location in spec file.
Resolves: BZ#681524 BZ#681527 BZ#681533

* Tue Mar 1 2011 Gal Hammer <ghammer@redhat.com> - 2.3.2-1
- updated the agent's makefile to work with auto-tools.
- added sub packages to support the single-sign-on feature.
- added -h parameter to shutdown command in order to halt the vm
  after shutdown.
- converted configuration file to have unix-style line ending.
- added redhat-rpm-config to build requirements in order to
  include *.pyc and *.pyo in the rpm file.
Resolves: BZ#680107 BZ#661713 BZ#679470 BZ#679451

* Wed Jan 19 2011 Gal Hammer <ghammer@redhat.com> - 2.3-7
- fixed files' mode to include execution flag.
Resolves: BZ#670476

* Mon Jan 17 2011 Gal Hammer <ghammer@redhat.com> - 2.3-6
- fixed the way the exit code was returned. the script always
  return 0 (success) because the main program ended and errors
  from the child process were lost.
Resolves: BZ#658092

* Thu Dec 23 2010 Gal Hammer <ghammer@redhat.com> - 2.3-5
- added description to startup/shutdown script in order to support
  chkconfig.
- a temporary fix to the 100% cpu usage when the vdsm doesn't
  listen to the virtio-serial.
Resolves: BZ#639702

* Sun Dec 19 2010 Gal Hammer <ghammer@redhat.com> - 2.3-4
- BZ#641886: lock command now handle both gnome and kde.
Resolves: BZ#641886

* Tue Dec 07 2010 Barak Azulay <bazulay@redhat.com> - 2.3-3
- BZ#660343 load virtio_console module before starting the daemon.
- BZ#660231 register daemon for startup.
Resolves: BZ#660343 BZ#660231

* Wed Dec 05 2010 Barak Azulay <bazulay@redhat.com> - 2.3-2
- initial build for RHEL-6
- works over vioserial 
- Agent reports only heartbeats, IPs, app list
- performs: shutdown & lock (the lock works only on gnome - when 
  ConsoleKit & gnome-screensaver is installed)
Resolves: BZ#613059
  
* Thu Aug 27 2010 Gal Hammer <ghammer@redhat.com> - 2.3-1
- Initial build.
